          page    55,120
;
          title    ASSEMBLER EXAMPLE USING STANDARD SHELL FOR MS-DOS 2
;
;
Dgroup    GROUP   Data
Cgroup    GROUP   Code
;
terminate EQU     4Ch
dos       EQU     21h
prt_stg   EQU     09h
srch_fst  EQU     0011h
srch_nxt  EQU     0012h
set_dta   EQU     001Ah
;
Data      SEGMENT public 'Data'
;
MSG_FLNM  DB      '........',' ','.',' '
MSG_EXT   DB      '...','  '
MSG_SIZE  DB      '       ','  '
MSG_DATE  DB      '        ','  '
MSG_TIME  DB      '      ','  '
new_line  DB      10,13,'$'
MSG_FLCNT DB      'NO FILES',10,13,'$'
FILES     DB      0
RADIX     DB      10
FCB_SRCH  DB      0,'???????????'
          DB      25 dup (?)
BFR_SRCH  DB      128 dup (?)
;
HEX_TAB   DB      '0123456789ABCDEF'
;
Data      ENDS
            page
;
MIKES_STACK SEGMENT STACK
;
            DW      100 dup (?)
TOS         EQU         this word
;
MIKES_STACK ENDS
;
;
Code      SEGMENT public 'Code'
;
          ASSUME  CS:Cgroup,DS:Dgroup
;
ComLnk    PROC    NEAR
;
ENTRY:
          MOV     ax,MIKES_STACK      ; get Stack Segment Origin
          MOV     SS,ax               ;     and initialize the SS register
          MOV     SP,offset TOS       ;         set SP to Top Of Stack
;
          CALL    User_Prog           ; RUN User's Routine
;
          MOV     ah,terminate        ;     Pass control
          INT     dos                 ;                  to COMMAND
;
ComLnk    ENDP
;
;
;
User_Prog:
;
          MOV     ax,Data   ; get Data Segment Origin
          MOV     DS,ax     ;     and initialize the DS register
;
          MOV     dx,offset new_line
          MOV     ah,prt_stg
          INT     dos
;
;
          MOV     dx,offset BFR_SRCH
          MOV     ah,set_dta
          INT     dos
          page
;
          MOV     dx,offset FCB_SRCH
          MOV     ah,srch_fst
          INT     dos
          CMP     al,00FFh
          JNE     CONT
          JMP     EXIT_END
;
CONT:
          MOV     cx,8
          XOR     bx,bx
NEXT_CHR:
          MOV     al,offset BFR_SRCH+1[bx]
          MOV     offset MSG_FLNM[bx],al
          INC     bx
          LOOP    NEXT_CHR
;
          MOV     cx,3
          XOR     bx,bx
NEXT_CHRx:
          MOV     al,offset BFR_SRCH+9[bx]
          MOV     offset MSG_EXT[bx],al
          INC     bx
          LOOP    NEXT_CHRx
          MOV     dx,offset MSG_FLNM
          MOV     ah,prt_stg
          INT     dos
;
          INC     FILES
;
SEARCH_NEXT:
          MOV     dx,offset FCB_SRCH
          MOV     ah,srch_nxt
          INT     dos
          CMP     al,00FFh
          JE      END
;
          MOV     cx,8
          XOR     bx,bx
NEXT_CHAR:
          MOV     al,offset BFR_SRCH+1[bx]
          MOV     offset MSG_FLNM[bx],al
          INC     bx
          LOOP    NEXT_CHAR
          page
;
          MOV     cx,3
          XOR     bx,bx
NEXT_CHARx:
          MOV     al,offset BFR_SRCH+9[bx]
          MOV     offset MSG_EXT[bx],al
          INC     bx
          LOOP    NEXT_CHARx
          MOV     dx,offset MSG_FLNM
          MOV     ah,prt_stg
          INT     dos
;
          INC     FILES
          JMP     SEARCH_NEXT
;
END:
          MOV     al,FILES
          XOR     ah,ah
          XOR     bx,bx
          DIV     RADIX
          MOV     bl,al
          MOV     al,HEX_TAB[bx]
          MOV     MSG_FLCNT,al
          MOV     bl,ah
          MOV     al,HEX_TAB[bx]
          MOV     MSG_FLCNT[1],al
          MOV     dx,offset MSG_FLCNT
          MOV     ah,prt_stg
          INT     dos
;
EXIT_END:
;
;
          RET               ; RETURN to Exit procedure
;
Code      ENDS
;
          END     ENTRY

